/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef QVDEFINES_H
#define QVDEFINES_H

#include <math.h>

#define	POW2(X)			((X)*(X))
#define SIGN(X)			(((X)>=0)?1:-1)
#define	ABS(X)			(((X)>0)?(X):(-(X)))
#define MIN(X,Y)		(((X)<(Y))?(X):(Y))
#define MAX(X,Y)		(((X)>(Y))?(X):(Y))
#define	RANDOM(MIN, MAX)	(rand()%((MAX)-(MIN)+1) + (MIN))

#define PI		(3.14159265358979323846)
#define EPSILON		(10E-6)

typedef unsigned char 	uChar;		// Ipp8u	1 bytes
typedef unsigned short 	uShort;		// Ipp16u	2 "
typedef unsigned int 	uInt;		// Ipp32u	4 "
typedef signed char 	sChar;		// Ipp8s	1 ...
typedef signed short 	sShort;		// Ipp16s	2
typedef signed int 	sInt;		// Ipp32s	4
//typedef __INT64 	sLong;		// Ipp64s	8 (not estandar type)
//typedef __UINT64 	uLong;		// Ipp64u	8 (not estandar type)
typedef float 		sFloat;		// Ipp32f	4
typedef double 		sDouble;	// Ipp64f	8

#endif
