/*
 *	Copyright (C) 2007. PARP Research Group.
 *	<http://perception.inf.um.es>
 *	University of Murcia, Spain.
 *
 *	This file is part of the QVision library.
 *
 *	QVision is free software: you can redistribute it and/or modify
 *	it under the terms of the GNU Lesser General Public License as
 *	published by the Free Software Foundation, version 3 of the License.
 *
 *	QVision is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with QVision. If not, see <http://www.gnu.org/licenses/>.
 */

/// @file qvimagebuffer.cpp
/// @brief File from the QVision library.
/// @author PARP Research Group. University of Murcia, Spain.

#include "qvimagebuffer.h"

// Copy constructors
#define	CREATE_COPY_CONSTRUCTOR(TYPE, C)											\
template <> QVImageBuffer<TYPE,C>::QVImageBuffer(const QVImageBuffer<TYPE,C> &imageBuffer): QSharedData(imageBuffer),		\
	data(NULL)														\
	{															\
	qDebug() << "QVImageBuffer<uChar, 1>::QVImageBuffer(" << imageBuffer.getCols() << "," << imageBuffer.getRows() << ")";	\
	allocData(imageBuffer.getCols(), imageBuffer.getRows());								\
	memcpy(this->data, imageBuffer.getReadData(), this->dataSize);								\
	qDebug() << "QVImageBuffer<uChar, 1>::QVImageBuffer() <- return";							\
	}

CREATE_COPY_CONSTRUCTOR(uChar, 1);
CREATE_COPY_CONSTRUCTOR(uChar, 3);
CREATE_COPY_CONSTRUCTOR(uShort, 1);
CREATE_COPY_CONSTRUCTOR(uShort, 3);
CREATE_COPY_CONSTRUCTOR(sShort, 1);
CREATE_COPY_CONSTRUCTOR(sShort, 3);
CREATE_COPY_CONSTRUCTOR(sInt, 1);
CREATE_COPY_CONSTRUCTOR(sInt, 3);
// CREATE_COPY_CONSTRUCTOR(uInt, 1);
// CREATE_COPY_CONSTRUCTOR(uInt, 3);
CREATE_COPY_CONSTRUCTOR(sFloat, 1);
CREATE_COPY_CONSTRUCTOR(sFloat, 3);
// CREATE_COPY_CONSTRUCTOR(sDouble, 1);
// CREATE_COPY_CONSTRUCTOR(sDouble, 3);
