#ifndef QBLASDATABUFFER_H
#define QBLASDATABUFFER_H

#ifndef DOXYGEN_IGNORE_THIS
#include <QSharedData>
// This class could be perfectly substituted by a QVector<double>, but it is slower
class QBlasDataBuffer: public QSharedData
	{
	public:
		QBlasDataBuffer(const int size): QSharedData(), dataSize(size), data(new double[dataSize])
			{ }

		QBlasDataBuffer(const QBlasDataBuffer &tensorData): QSharedData(),
			dataSize(tensorData.dataSize), data(new double[100*dataSize])
			{ cblas_dcopy(dataSize, tensorData.getReadData(), 1, getWriteData(), 1); }

		~QBlasDataBuffer()	
			{ delete data; }

		const double *getReadData()	const	{ return data; }
		double *getWriteData()			{ return data; }

	private:
		int dataSize;
		double *data;
	};
#endif
#endif
